/**
 * $Id: mh_key.c 22 2006-05-03 20:12:20Z alexeen $
 */
#include <stdlib.h>

#include "mh_key.h"

/**
 * minheap_compare: Compares two min-heap keys and
 *   returns a value between -1 to 1.
 * k1 - The key comparing with k2.
 * k2 - The key comparing with k1.
 * @return Returns -1 if k1 < k2, 0 if k1 == k2,
 *   1 if k1 > k2.
 */
int minheap_compare(void *k1, void *k2)
{
	mh_key_t *key1 = (mh_key_t *)k1;
	mh_key_t *key2 = (mh_key_t *)k2;

	if (key1->key < key2->key)
	{
		return -1;
	}
	else if (key1->key > key2->key)
	{
		return 1;
	}

	return 0;
}
