/**
 * $Id: minheap.h 22 2006-05-03 20:12:20Z alexeen $
 */
#ifndef __MIN_HEAP_H__
#define __MIN_HEAP_H__

/**
 * Minimum-heap element structure.
 */
typedef struct _minheap_elm_t
{
	void *key,  /** Key of this element. **/
		   *data; /** Data of this element. **/
} minheap_elm_t;

/**
 * Minimum-heap structure.
 */
typedef struct _minheap_t
{
	size_t size,                 /** The heap size. **/
		     s_size;               /** Available storage size. **/
	struct _minheap_elm_t *heap; /** Heap storage. **/
} minheap_t;

minheap_t *minheap_init(void);
int minheap_insert(minheap_t *h, void *key, void *data);
void *minheap_extract_min(minheap_t *h);
void minheap_destroy(minheap_t *h);
size_t minheap_size(minheap_t *h);
size_t minheap_s_size(minheap_t *h);
void minheap_print(minheap_t *h);

/** Need a definition to compare keys. **/
extern int minheap_compare(void *k1, void *k2);

#endif /** __MIN_HEAP_H__ **/
